from pygame import *
from OpenGL.GL import *
from OpenGL.GLU import *
import sys,math,view,map
'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "lib"
directory.
'''
import data
class App:
	def __init__(self,x,y,\
		damax,dbmax,dwmax,\
		adiff,bdiff,wdiff,\
		amax=math.pi*2,bmax=math.pi/4-math.pi/8,wmax=math.pi/8,\
		amin=0,bmin=0,wmin=math.pi/8\
		):
		self.initdisp(x,y)
		self.initvar(damax,dbmax,dwmax,adiff,bdiff,wdiff,amax,bmax,wmax,amin,bmin,wmin)
	def initdisp(self,x,y):
		self.x=x
		self.y=y
		self.half=y/2
		s=display.set_mode((x,y),OPENGL|DOUBLEBUF|FULLSCREEN)
		#dont konw about this rows
		glEnable(GL_CULL_FACE)
		#glCullFace(GL_FRONT)
		#glFrontFace(GL_CCW)
		#####
		#dont know ifd this si the right funk or oder
		glDepthFunc(GL_LESS)#QUAL)
		glEnable(GL_DEPTH_TEST)
		#####
		#fog
		glEnable(GL_FOG)
		glFogi(GL_FOG_MODE, GL_LINEAR)
		glFogf(GL_FOG_START,0.)
		glFogf(GL_FOG_END,40.)
		glFogfv(GL_FOG_COLOR,(0,0,0))
		###
		glMatrixMode(GL_PROJECTION)
		glLoadIdentity()
		glOrtho(-1*(x/y),1*(x/y),-1,1,-1,1)
		gluPerspective(18,(x/y),0,1)
		glMatrixMode(GL_MODELVIEW)
		glTranslated(0,0,-2)
		mixer.init()
	def initvar(self,damax,dbmax,dwmax,adiff,bdiff,wdiff,amax,bmax,wmax,amin,bmin,wmin):
		self.sBoost=mixer.Sound("boost.wav")
		self.sBoostend=mixer.Sound("boostend.wav")
		self.sBoostend.set_volume(0.2)
		self.clock=time.Clock()
		self.pos=0
		self.vel=0
		self.acc=0.01
		self.gen=map.simpleMap(damax,dbmax,dwmax,adiff,bdiff,wdiff,amax,bmax,wmax,amin,bmin,wmin)
		self.a,self.b,self.w=self.gen.next()
		self.queue=[map.Sector(self.gen.next()) for n in range(25)]
		self.boost=False
		self.end=1000
		self.laptime=0
	def doEvent(self):
		for e in event.get():
			if e.type==QUIT:
				sys.exit()
			elif e.type==MOUSEBUTTONDOWN:
				self.sBoost.play()
				self.sBoostend.play(-1)
				self.boost=True
			elif e.type==MOUSEBUTTONUP:
				self.boost=False
				self.sBoostend.stop()
				self.vel=self.acc
				self.acc=0.01
			elif e.type==MOUSEMOTION:
				mx,my=e.pos
				my=(my-self.half)
				mx=max(min(mx-self.x/2,self.half),-self.half)
				l=math.hypot(mx,my)
				if l: mx,my=mx/l,my/l
				self.a=math.acos(mx)*(1 if my<0 else -1)
				self.b=min(l,self.half)/self.y*math.pi*2#-math.pi/2.
			elif e.type==KEYDOWN:
				if e.key==K_UP:
					glTranslated(0,0,-2)
				elif e.key==K_DOWN:
					glTranslated(0,0,2)
				elif e.key==K_ESCAPE:
					sys.exit()
				
	def doDraw(self):
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
		self.step=1.5
		glEnable(GL_DEPTH_TEST)	
		view.drawSectors(self.queue,offset=self.pos,step=self.step)
		glDisable(GL_DEPTH_TEST)		
		view.drawPlayer(self.a,self.b,(1,1,1),10)
		s=self.queue[5]		
		view.drawPlayer(s.a,s.b,(0.5,0,1),5)
		view.drawPlayer(s.a,s.b+s.w,(0.25,0,1),2)
		view.drawPlayer(s.a,s.b-s.w,(0.25,0,1),2)
		glFinish()
		display.flip()
	def run(self):
		while True:
			prog=self.clock.tick()
			self.laptime+=prog
			self.doEvent()
			self.doDraw()

			s=self.queue[5]
			if self.vel<0:self.vel=0
			#if int(self.a/math.pi*2):self.a-=int(self.a/math.pi*2)*math.pi*2
			if not ((-s.w<(self.a+self.b)-(s.a+s.b)<s.w and -s.w<(self.a-self.b)-(s.a-s.b)<+s.w) or (s.w<(self.a+self.b)-(s.a+s.b)<-s.w and s.w<(self.a-self.b)-(s.a-s.b)<-s.w)):
				#print self.a,s.a
				#print (-s.w),"<",((self.a+self.b)-(s.a+s.b)),"<",(s.w)," and ",(-s.w),"<",((self.a-self.b)-(s.a-s.b)),"<",(s.w)
				self.vel=0
				self.acc=.01
			
			if self.boost:
				self.pos-=self.vel
				self.vel+=self.acc*prog/1000.
				self.acc+=0.1*prog/1000.
			else:
				self.pos-=self.vel
				self.vel+=self.acc*prog/1000.

			if self.pos<=-self.step:
				#print "passed sector"
				self.pos=0
				self.end-=1
				print "end",self.end
				if self.end==0:
					print "u won in",self.laptime,"millisceonds"
					#raw_input("press enter...")
					sys.exit()
				self.queue.pop(0)
				self.queue.append(map.Sector(self.gen.next()))
			#print self.clock.get_fps()
				
			
		
def main():
	a=raw_input("easy,medium,hard,twisted? ")
	while a!="toeasy" and a!="easy" and a!="medium" and a!="hard" and a!="twisted":
		print "lets try agen."
		a=raw_input("toeasy,easy,medium,hard,twisted? ")		
	if a=="toeasy":
		app=App(1280.,1024.,0,0,0,0,0,0,amin=0,bmin=0,wmin=math.pi/3,amax=0,bmax=0,wmax=math.pi/3)
	elif a=="easy":
		app=App(1280.,1024.,0,0,math.pi/10,0,0,math.pi/20,amin=0,bmin=0,wmin=math.pi/32,amax=0,bmax=0,wmax=math.pi/4)
	elif a=="medium":
		app=App(1280.,1024.,math.pi/100,0,0,math.pi/200,0,0,amin=0,bmin=0,wmin=math.pi/8,amax=math.pi*2,bmax=0,wmax=math.pi/8)
	elif a=="hard":
		app=App(1280.,1024.,math.pi/100,math.pi/100,0,math.pi/200,math.pi/200,0,amin=0,bmin=-math.pi/2+math.pi/8,wmin=math.pi/8,amax=math.pi*2,bmax=math.pi/2-math.pi/8,wmax=math.pi/8)
	elif a=="twisted":
		app=App(1280.,1024.,math.pi/10,math.pi/100,math.pi/50,math.pi/50,math.pi/1000,math.pi/50,wmin=math.pi/8,wmax=math.pi/8)
		
	app.run()

	
if __name__=="__main__":
	main()
